Index: /palm/trunk/SOURCE/diffusivities.f90
===================================================================
--- /palm/trunk/SOURCE/diffusivities.f90	(revision 2231)
+++ /palm/trunk/SOURCE/diffusivities.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new topography and surface concept
 ! 
 ! Former revisions:
@@ -89,8 +89,10 @@
     USE control_parameters,                                                    &
         ONLY:  atmos_ocean_sign, e_min, g, outflow_l, outflow_n, outflow_r,    &
-                outflow_s, use_single_reference_value, wall_adjustment
+               outflow_s, use_single_reference_value, wall_adjustment,         &
+               wall_adjustment_factor
                 
     USE indices,                                                               &
-        ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb_s_inner, nzb, nzt
+        ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt,           &
+               wall_flags_0
     USE kinds
     
@@ -100,4 +102,7 @@
         ONLY :  rmask, statistic_regions, sums_l_l
 
+    USE surface_mod,                                                           &
+        ONLY :  bc_h
+
     IMPLICIT NONE
 
@@ -105,4 +110,5 @@
     INTEGER(iwp) ::  j                   !<
     INTEGER(iwp) ::  k                   !<
+    INTEGER(iwp) ::  m                   !<
     INTEGER(iwp) ::  omp_get_thread_num  !<
     INTEGER(iwp) ::  sr                  !<
@@ -110,4 +116,5 @@
 
     REAL(wp)     ::  dvar_dz             !<
+    REAL(wp)     ::  flag                !<
     REAL(wp)     ::  l                   !<
     REAL(wp)     ::  ll                  !<
@@ -129,5 +136,5 @@
 !
 !-- Compute the turbulent diffusion coefficient for momentum
-    !$OMP PARALLEL PRIVATE (dvar_dz,i,j,k,l,ll,l_stable,sqrt_e,sr,tn)
+    !$OMP PARALLEL PRIVATE (dvar_dz,i,j,k,l,ll,l_stable,sqrt_e,sr,tn,flag)
 !$  tn = omp_get_thread_num()
 
@@ -138,8 +145,7 @@
        DO  i = nxlg, nxrg
           DO  j = nysg, nyng
-             DO  k = 1, nzt
-                IF ( k > nzb_s_inner(j,i) )  THEN
-                   e(k,j,i) = MAX( e(k,j,i), e_min )
-                ENDIF
+             DO  k = nzb+1, nzt
+                e(k,j,i) = MAX( e(k,j,i), e_min ) *                            &
+                        MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
              ENDDO
           ENDDO
@@ -150,46 +156,46 @@
     DO  i = nxlg, nxrg
        DO  j = nysg, nyng
-          DO  k = 1, nzt
-
-             IF ( k > nzb_s_inner(j,i) )  THEN
-
-                sqrt_e = SQRT( e(k,j,i) )
-!
-!--             Determine the mixing length
-                dvar_dz = atmos_ocean_sign * &  ! inverse effect of pt/rho_ocean gradient
-                          ( var(k+1,j,i) - var(k-1,j,i) ) * dd2zu(k)
-                IF ( dvar_dz > 0.0_wp ) THEN
-                   IF ( use_single_reference_value )  THEN
-                      l_stable = 0.76_wp * sqrt_e /                            &
-                                    SQRT( g / var_reference * dvar_dz ) + 1E-5_wp
-                   ELSE
-                      l_stable = 0.76_wp * sqrt_e /                            &
-                                    SQRT( g / var(k,j,i) * dvar_dz ) + 1E-5_wp
-                   ENDIF
+          DO  k = nzb+1, nzt
+
+             flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
+
+             sqrt_e = SQRT( e(k,j,i) )
+!
+!--          Determine the mixing length
+             dvar_dz = atmos_ocean_sign * &  ! inverse effect of pt/rho_ocean gradient
+                       ( var(k+1,j,i) - var(k-1,j,i) ) * dd2zu(k)
+             IF ( dvar_dz > 0.0_wp ) THEN
+                IF ( use_single_reference_value )  THEN
+                   l_stable = 0.76_wp * sqrt_e /                               &
+                                 SQRT( g / var_reference * dvar_dz ) + 1E-5_wp
                 ELSE
-                   l_stable = l_grid(k)
+                   l_stable = 0.76_wp * sqrt_e /                               &
+                                 SQRT( g / var(k,j,i) * dvar_dz ) + 1E-5_wp
                 ENDIF
-!
-!--             Adjustment of the mixing length
-                IF ( wall_adjustment )  THEN
-                   l  = MIN( l_wall(k,j,i), l_grid(k), l_stable )
-                   ll = MIN( l_wall(k,j,i), l_grid(k) )
-                ELSE
-                   l  = MIN( l_grid(k), l_stable )
-                   ll = l_grid(k)
-                ENDIF
-
-      !
-      !--       Compute diffusion coefficients for momentum and heat
-                km(k,j,i) = 0.1_wp * l * sqrt_e
-                kh(k,j,i) = ( 1.0_wp + 2.0_wp * l / ll ) * km(k,j,i)
-
-!
-!--             Summation for averaged profile (cf. flow_statistics)
-                DO  sr = 0, statistic_regions
-                   sums_l_l(k,sr,tn) = sums_l_l(k,sr,tn) + l * rmask(j,i,sr)
-                ENDDO
-
+             ELSE
+                l_stable = l_grid(k)
              ENDIF
+!
+!--          Adjustment of the mixing length
+             IF ( wall_adjustment )  THEN
+                l  = MIN( wall_adjustment_factor * l_wall(k,j,i), l_grid(k),   &
+                          l_stable )
+                ll = MIN( wall_adjustment_factor * l_wall(k,j,i), l_grid(k) )
+             ELSE
+                l  = MIN( l_grid(k), l_stable )
+                ll = l_grid(k)
+             ENDIF
+!
+!--          Compute diffusion coefficients for momentum and heat
+             km(k,j,i) = 0.1_wp * l * sqrt_e                      * flag
+             kh(k,j,i) = ( 1.0_wp + 2.0_wp * l / ll ) * km(k,j,i) * flag
+     
+
+!
+!--          Summation for averaged profile (cf. flow_statistics)
+             DO  sr = 0, statistic_regions
+                sums_l_l(k,sr,tn) = sums_l_l(k,sr,tn) + l * rmask(j,i,sr)      &
+                                                          * flag
+             ENDDO
 
           ENDDO
@@ -202,17 +208,39 @@
 
 !
-!-- Set vertical boundary values (Neumann conditions both at bottom and top).
+!-- Set vertical boundary values (Neumann conditions both at upward- and 
+!-- downward facing walls. To set wall-boundary values, the surface data type 
+!-- is applied.
 !-- Horizontal boundary conditions at vertical walls are not set because
-!-- so far vertical walls require usage of a Prandtl-layer where the boundary
-!-- values of the diffusivities are not needed
+!-- so far vertical surfaces require usage of a Prandtl-layer where the boundary
+!-- values of the diffusivities are not needed.
+!-- Upward-facing
+    !$OMP PARALLEL DO PRIVATE( i, j, k )
+    DO  m = 1, bc_h(0)%ns
+       i = bc_h(0)%i(m)            
+       j = bc_h(0)%j(m)
+       k = bc_h(0)%k(m)
+       km(k-1,j,i) = km(k,j,i)
+       kh(k-1,j,i) = kh(k,j,i)
+    ENDDO
+!
+!-- Downward facing surfaces
+    !$OMP PARALLEL DO PRIVATE( i, j, k )
+    DO  m = 1, bc_h(1)%ns
+       i = bc_h(1)%i(m)            
+       j = bc_h(1)%j(m)
+       k = bc_h(1)%k(m)
+       km(k+1,j,i) = km(k,j,i)
+       kh(k+1,j,i) = kh(k,j,i)
+    ENDDO
+!
+!-- Model top
     !$OMP PARALLEL DO
     DO  i = nxlg, nxrg
        DO  j = nysg, nyng
-          km(nzb_s_inner(j,i),j,i) = km(nzb_s_inner(j,i)+1,j,i)
-          km(nzt+1,j,i)            = km(nzt,j,i)
-          kh(nzb_s_inner(j,i),j,i) = kh(nzb_s_inner(j,i)+1,j,i)
-          kh(nzt+1,j,i)            = kh(nzt,j,i)
+          km(nzt+1,j,i) = km(nzt,j,i)
+          kh(nzt+1,j,i) = kh(nzt,j,i)
        ENDDO
     ENDDO
+
 
 !
Index: /palm/trunk/SOURCE/disturb_field.f90
===================================================================
--- /palm/trunk/SOURCE/disturb_field.f90	(revision 2231)
+++ /palm/trunk/SOURCE/disturb_field.f90	(revision 2232)
@@ -20,5 +20,7 @@
 ! Current revisions:
 ! ------------------
-! 
+! Modify referenced parameter for disturb_field, instead of nzb_uv_inner, pass
+! character to identify the respective grid (u- or v-grid). 
+! Set perturbations within topography to zero using flags.
 ! 
 ! Former revisions:
@@ -70,8 +72,8 @@
 !> order in every case. The perturbation range is steered by dist_range.
 !------------------------------------------------------------------------------!
- SUBROUTINE disturb_field( nzb_uv_inner, dist1, field )
+ SUBROUTINE disturb_field( var_char, dist1, field )
  
 
-    USE control_parameters,   &
+    USE control_parameters,                                                    &
         ONLY:  dist_nxl, dist_nxr, dist_nyn, dist_nys, dist_range,             &
                disturbance_amplitude, disturbance_created,                     &
@@ -83,5 +85,6 @@
         
     USE indices,                                                               &
-        ONLY:  nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
+        ONLY:  nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzb_max, &
+               nzt, wall_flags_0
         
     USE kinds
@@ -96,9 +99,10 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i  !<
-    INTEGER(iwp) ::  j  !<
-    INTEGER(iwp) ::  k  !<
-    
-    INTEGER(iwp) ::  nzb_uv_inner(nysg:nyng,nxlg:nxrg) !<
+    CHARACTER (LEN = *) ::  var_char !< flag to distinguish betwenn u- and v-component
+
+    INTEGER(iwp) ::  flag_nr !< number of respective flag for u- or v-grid 
+    INTEGER(iwp) ::  i       !< index variable
+    INTEGER(iwp) ::  j       !< index variable
+    INTEGER(iwp) ::  k       !< index variable
 
     REAL(wp) ::  randomnumber  !<
@@ -111,5 +115,7 @@
 
     CALL cpu_log( log_point(20), 'disturb_field', 'start' )
-
+!
+!-- Set flag number, 20 for u-grid, 21 for v-grid, required to mask topography
+    flag_nr = MERGE( 20, 21, TRIM(var_char) == 'u' )
 !
 !-- Create an additional temporary array and initialize the arrays needed
@@ -224,5 +230,9 @@
        DO  i = nxlg, nxrg
           DO  j = nysg, nyng
-             dist1(nzb:nzb_uv_inner(j,i)+1,j,i) = 0.0_wp
+             DO  k = nzb, nzb_max
+                dist1(k,j,i) = MERGE( dist1(k,j,i), 0.0_wp,                    &
+                                      BTEST( wall_flags_0(k,j,i), flag_nr )    &
+                                    )
+             ENDDO
           ENDDO
        ENDDO
Index: /palm/trunk/SOURCE/disturb_heatflux.f90
===================================================================
--- /palm/trunk/SOURCE/disturb_heatflux.f90	(revision 2231)
+++ /palm/trunk/SOURCE/disturb_heatflux.f90	(revision 2232)
@@ -20,5 +20,7 @@
 ! Current revisions:
 ! ------------------
-! 
+! Adjustment according new surface data type.
+! Implemented parallel random number generator to obtain always the same 
+! random number distribution regardless of the processor distribution.
 ! 
 ! Former revisions:
@@ -60,16 +62,13 @@
 !> Generate random, normally distributed heatflux values and store them as the
 !> near-surface heatflux.
-!> On parallel computers, too, this random generator is called at all grid points
-!> of the total array in order to guarantee the same random distribution of the
-!> total array regardless of the number of processors used during the model run.
 !------------------------------------------------------------------------------!
- SUBROUTINE disturb_heatflux
+ SUBROUTINE disturb_heatflux( surf )
  
 
     USE arrays_3d,                                                             &
-        ONLY:  shf, heatflux_input_conversion
+        ONLY:  heatflux_input_conversion
         
     USE control_parameters,                                                    &
-        ONLY:  iran, surface_heatflux, wall_heatflux
+        ONLY:  iran, surface_heatflux, random_generator, wall_heatflux
         
     USE cpulog,                                                                &
@@ -79,13 +78,24 @@
     
     USE indices,                                                               &
-        ONLY:  nx, nxl, nxr, ny, nyn, nys, nzb, nzb_s_inner
+        ONLY:  nzb
+
+    USE random_generator_parallel,                                             &
+        ONLY:  random_number_parallel, random_seed_parallel, random_dummy,     &
+               id_random_array, seq_random_array
+
+    USE surface_mod,                                                           &
+        ONLY:  surf_type
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  j  !<
-    INTEGER(iwp) ::  i  !<
+    INTEGER(iwp) ::  i  !< grid index, x direction
+    INTEGER(iwp) ::  j  !< grid index, y direction
+    INTEGER(iwp) ::  k  !< grid index, z direction
+    INTEGER(iwp) ::  m  !< loop variables over surface elements
     
     REAL(wp) ::  random_gauss  !<
     REAL(wp) ::  randomnumber  !<
+
+    TYPE(surf_type) ::  surf   !< surface-type variable
 
 
@@ -93,26 +103,51 @@
 
 !
-!-- Generate random disturbances and store them
-    DO  i = 0, nx
-       DO  j = 0, ny
-          randomnumber = random_gauss( iran, 5.0_wp )
-          IF ( nxl <= i  .AND.  nxr >= i  .AND.  nys <= j  .AND.  nyn >= j )   &
-          THEN
-             IF ( nzb_s_inner(j,i) == 0 )  THEN
-                shf(j,i) = randomnumber * surface_heatflux                     &
-                           * heatflux_input_conversion(nzb)
-             ELSE
+!-- Generate random disturbances and store them. Note, if 
+!-- random_generator /= 'random-parallel' it is not guaranteed to obtain  
+!-- the same random distribution if the number of processors is changed. 
+    IF ( random_generator /= 'random-parallel' )  THEN
+
+       DO  m = 1, surf%ns
+
+          k = surf%k(m)
+
+          randomnumber = random_gauss( iran, 5.0_wp )      
 !
-!--             Over topography surface_heatflux is replaced by wall_heatflux(0)
-                shf(j,i) = randomnumber * wall_heatflux(0)                     &
-                           * heatflux_input_conversion(nzb_s_inner(j,i))
-             ENDIF
+!--       k-1 is topography top index. If this is 0, set surface heatflux. Over
+!--       topography surface_heatflux is replaced by wall_heatflux(0).
+          IF ( k-1 == 0 )  THEN
+             surf%shf(m) = randomnumber * surface_heatflux                     &
+                              * heatflux_input_conversion(nzb)
+          ELSE
+             surf%shf(m) = randomnumber * wall_heatflux(0)                     &
+                              * heatflux_input_conversion(k-1)
           ENDIF
        ENDDO
-    ENDDO
+    ELSE
 
+       DO  m = 1, surf%ns
+
+          i = surf%i(m)
+          j = surf%j(m)
+          k = surf%k(m)
+
+          CALL random_seed_parallel( put=seq_random_array(:, j, i) )
+          CALL random_number_parallel( random_dummy )    
 !
-!-- Exchange lateral boundary conditions for the heatflux array
-    CALL exchange_horiz_2d( shf )
+!--       k-1 is topography top index. If this is 0, set surface heatflux. Over
+!--       topography surface_heatflux is replaced by wall_heatflux(0).
+          IF ( k-1 == 0 )  THEN
+             surf%shf(m) = ( random_dummy - 0.5_wp ) * surface_heatflux        &
+                              * heatflux_input_conversion(nzb)
+          ELSE
+             surf%shf(m) = ( random_dummy - 0.5_wp ) * wall_heatflux(0)        &
+                              * heatflux_input_conversion(k-1)
+          ENDIF
+
+          CALL random_seed_parallel( get=seq_random_array(:, j, i) )
+
+       ENDDO
+
+    ENDIF
 
     CALL cpu_log( log_point(23), 'disturb_heatflux', 'stop' )
Index: /palm/trunk/SOURCE/eqn_state_seawater.f90
===================================================================
--- /palm/trunk/SOURCE/eqn_state_seawater.f90	(revision 2231)
+++ /palm/trunk/SOURCE/eqn_state_seawater.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new topography and surface concept
 ! 
 ! Former revisions:
@@ -120,24 +120,32 @@
            ONLY:  hyp, prho, pt_p, rho_ocean, sa_p
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nyn, nys, nzb_s_inner, nzt
+           ONLY:  nxl, nxr, nyn, nys, nzb, nzt, wall_flags_0
+
+       USE surface_mod,                                                        &
+          ONLY :  bc_h
 
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i  !<
-       INTEGER(iwp) ::  j  !<
-       INTEGER(iwp) ::  k  !<
-
-       REAL(wp) ::  pden  !<
-       REAL(wp) ::  pnom  !<
-       REAL(wp) ::  p1    !<
-       REAL(wp) ::  p2    !<
-       REAL(wp) ::  p3    !<
-       REAL(wp) ::  pt1   !<
-       REAL(wp) ::  pt2   !<
-       REAL(wp) ::  pt3   !<
-       REAL(wp) ::  pt4   !<
-       REAL(wp) ::  sa1   !<
-       REAL(wp) ::  sa15  !<
-       REAL(wp) ::  sa2   !<
+       INTEGER(iwp) ::  i       !< running index x direction
+       INTEGER(iwp) ::  j       !< running index y direction
+       INTEGER(iwp) ::  k       !< running index z direction
+       INTEGER(iwp) ::  l       !< running index of surface type, south- or north-facing wall
+       INTEGER(iwp) ::  m       !< running index surface elements
+       INTEGER(iwp) ::  surf_e  !< End index of surface elements at (j,i)-gridpoint
+       INTEGER(iwp) ::  surf_s  !< Start index of surface elements at (j,i)-gridpoint
+
+       REAL(wp) ::  flag   !< flag to mask topography grid points
+       REAL(wp) ::  pden   !<
+       REAL(wp) ::  pnom   !<
+       REAL(wp) ::  p1     !<
+       REAL(wp) ::  p2     !<
+       REAL(wp) ::  p3     !<
+       REAL(wp) ::  pt1    !<
+       REAL(wp) ::  pt2    !<
+       REAL(wp) ::  pt3    !<
+       REAL(wp) ::  pt4    !<
+       REAL(wp) ::  sa1    !<
+       REAL(wp) ::  sa15   !<
+       REAL(wp) ::  sa2    !<
        
                        
@@ -145,5 +153,5 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_s_inner(j,i)+1, nzt
+             DO  k = nzb+1, nzt
 !
 !--             Pressure is needed in dbar
@@ -171,8 +179,10 @@
                        den(7)*sa1*pt1   + den(8)*sa1*pt3 + den(9)*sa15    +    &
                        den(10)*sa15*pt2
-
+!
+!--             Predetermine flag to mask topography
+                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
 !
 !--             Potential density (without pressure terms)
-                prho(k,j,i) = pnom / pden
+                prho(k,j,i) = pnom / pden * flag
 
                 pnom = pnom +             nom(8)*p1      + nom(9)*p1*pt2  +    &
@@ -184,15 +194,33 @@
 !
 !--             In-situ density
-                rho_ocean(k,j,i) = pnom / pden
+                rho_ocean(k,j,i) = pnom / pden * flag
 
              ENDDO
 !
-!--          Neumann conditions are assumed at bottom and top boundary
-             prho(nzt+1,j,i)            = prho(nzt,j,i)
-             prho(nzb_s_inner(j,i),j,i) = prho(nzb_s_inner(j,i)+1,j,i)
-             rho_ocean(nzt+1,j,i)             = rho_ocean(nzt,j,i)
-             rho_ocean(nzb_s_inner(j,i),j,i)  = rho_ocean(nzb_s_inner(j,i)+1,j,i)
+!--          Neumann conditions are assumed at top boundary
+             prho(nzt+1,j,i)      = prho(nzt,j,i)
+             rho_ocean(nzt+1,j,i) = rho_ocean(nzt,j,i)
 
           ENDDO
+       ENDDO
+!
+!--    Neumann conditions at up/downward-facing surfaces
+       !$OMP PARALLEL DO PRIVATE( i, j, k )
+       DO  m = 1, bc_h(0)%ns
+          i = bc_h(0)%i(m)            
+          j = bc_h(0)%j(m)
+          k = bc_h(0)%k(m)
+          prho(k-1,j,i)      = prho(k,j,i)
+          rho_ocean(k-1,j,i) = rho_ocean(k,j,i)
+       ENDDO
+!
+!--    Downward facing surfaces
+       !$OMP PARALLEL DO PRIVATE( i, j, k )
+       DO  m = 1, bc_h(1)%ns
+          i = bc_h(1)%i(m)            
+          j = bc_h(1)%j(m)
+          k = bc_h(1)%k(m)
+          prho(k+1,j,i)      = prho(k,j,i)
+          rho_ocean(k+1,j,i) = rho_ocean(k,j,i)
        ENDDO
 
@@ -211,14 +239,34 @@
            
        USE indices,                                                            &
-           ONLY:  nzb_s_inner, nzt
+           ONLY:  nzb, nzt, wall_flags_0
+
+       USE surface_mod,                                                        &
+          ONLY :  bc_h
 
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i, j, k
-
-       REAL(wp)     ::  pden, pnom, p1, p2, p3, pt1, pt2, pt3, pt4, sa1, sa15, &
-                        sa2
-
-       DO  k = nzb_s_inner(j,i)+1, nzt
+       INTEGER(iwp) ::  i       !< running index x direction
+       INTEGER(iwp) ::  j       !< running index y direction
+       INTEGER(iwp) ::  k       !< running index z direction
+       INTEGER(iwp) ::  l       !< running index of surface type, south- or north-facing wall
+       INTEGER(iwp) ::  m       !< running index surface elements
+       INTEGER(iwp) ::  surf_e  !< End index of surface elements at (j,i)-gridpoint
+       INTEGER(iwp) ::  surf_s  !< Start index of surface elements at (j,i)-gridpoint
+
+       REAL(wp) ::  flag   !< flag to mask topography grid points
+       REAL(wp) ::  pden   !<
+       REAL(wp) ::  pnom   !<
+       REAL(wp) ::  p1     !<
+       REAL(wp) ::  p2     !<
+       REAL(wp) ::  p3     !<
+       REAL(wp) ::  pt1    !<
+       REAL(wp) ::  pt2    !<
+       REAL(wp) ::  pt3    !<
+       REAL(wp) ::  pt4    !<
+       REAL(wp) ::  sa1    !<
+       REAL(wp) ::  sa15   !<
+       REAL(wp) ::  sa2    !<
+
+       DO  k = nzb+1, nzt
 !
 !--       Pressure is needed in dbar
@@ -246,8 +294,10 @@
                  den(7)*sa1*pt1   + den(8)*sa1*pt3 + den(9)*sa15    +          &
                  den(10)*sa15*pt2
-
+!
+!--       Predetermine flag to mask topography
+          flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
 !
 !--       Potential density (without pressure terms)
-          prho(k,j,i) = pnom / pden
+          prho(k,j,i) = pnom / pden * flag
 
           pnom = pnom +             nom(8)*p1      + nom(9)*p1*pt2  +          &
@@ -258,15 +308,30 @@
 !
 !--       In-situ density
-          rho_ocean(k,j,i) = pnom / pden
-
-
-       ENDDO
-
-!
-!--    Neumann conditions are assumed at bottom and top boundary
-       prho(nzt+1,j,i)            = prho(nzt,j,i)
-       prho(nzb_s_inner(j,i),j,i) = prho(nzb_s_inner(j,i)+1,j,i)
-       rho_ocean(nzt+1,j,i)             = rho_ocean(nzt,j,i)
-       rho_ocean(nzb_s_inner(j,i),j,i)  = rho_ocean(nzb_s_inner(j,i)+1,j,i)
+          rho_ocean(k,j,i) = pnom / pden * flag
+
+
+       ENDDO
+!
+!--    Neumann conditions at up/downward-facing walls
+       surf_s = bc_h(0)%start_index(j,i)   
+       surf_e = bc_h(0)%end_index(j,i)   
+       DO  m = surf_s, surf_e
+          k                  = bc_h(0)%k(m)
+          prho(k-1,j,i)      = prho(k,j,i)
+          rho_ocean(k-1,j,i) = rho_ocean(k,j,i)
+       ENDDO
+!
+!--    Downward facing surfaces
+       surf_s = bc_h(1)%start_index(j,i)   
+       surf_e = bc_h(1)%end_index(j,i)   
+       DO  m = surf_s, surf_e
+          k                  = bc_h(1)%k(m)
+          prho(k+1,j,i)      = prho(k,j,i)
+          rho_ocean(k+1,j,i) = rho_ocean(k,j,i)
+       ENDDO
+!
+!--    Neumann condition are assumed at top boundary
+       prho(nzt+1,j,i)      = prho(nzt,j,i)
+       rho_ocean(nzt+1,j,i) = rho_ocean(nzt,j,i)
 
     END SUBROUTINE eqn_state_seawater_ij
